(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser'), require('hammerjs')) :
    typeof define === 'function' && define.amd ? define('ngx-hammerjs-carousel', ['exports', '@angular/core', '@angular/platform-browser', 'hammerjs'], factory) :
    (global = global || self, factory(global['ngx-hammerjs-carousel'] = {}, global.ng.core, global.ng.platformBrowser, global.Hammer));
}(this, (function (exports, core, platformBrowser, Hammer) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var HammerjsCarouselComponent = /** @class */ (function () {
        function HammerjsCarouselComponent(cdRef) {
            this.cdRef = cdRef;
            this.activeSlide = 0;
            this.sensitivity = 10;
        }
        Object.defineProperty(HammerjsCarouselComponent.prototype, "slides", {
            get: function () {
                return this.slidesInternal;
            },
            set: function (value) {
                this.slidesInternal = value;
                if (this.slides != null) {
                    this.slideCount = this.slides.length;
                }
                else {
                    this.slideCount = 0;
                }
            },
            enumerable: true,
            configurable: true
        });
        HammerjsCarouselComponent.prototype.ngOnInit = function () {
            this.isTouchDevice = 'ontouchstart' in window;
        };
        HammerjsCarouselComponent.prototype.ngAfterViewChecked = function () {
            var sliderWrapperElement = this.sliderWrapper.nativeElement;
            this.width = sliderWrapperElement.offsetWidth;
            this.sensitivity = this.width / 40;
            this.cdRef.detectChanges();
        };
        HammerjsCarouselComponent.prototype.onPan = function (e) {
            if (e.velocityX === 0 || Math.abs(e.velocityY) > Math.abs(e.velocityX)) {
                // Vertical scroll
                return;
            }
            var percentage = 100 / this.slideCount * e.deltaX / window.innerWidth;
            var transformPercentage = percentage - 100 / this.slideCount * this.activeSlide;
            this.sliderTransformStyle = 'translateX( ' + transformPercentage + '% )';
            if (e.isFinal) {
                if (e.velocityX > 1) {
                    this.goToSlide(this.activeSlide - 1);
                }
                else if (e.velocityX < -1) {
                    this.goToSlide(this.activeSlide + 1);
                }
                else {
                    if (percentage <= -(this.sensitivity / this.slideCount)) {
                        this.goToSlide(this.activeSlide + 1);
                    }
                    else if (percentage >= (this.sensitivity / this.slideCount)) {
                        this.goToSlide(this.activeSlide - 1);
                    }
                    else {
                        this.goToSlide(this.activeSlide);
                    }
                }
            }
        };
        HammerjsCarouselComponent.prototype.previousSlide = function () {
            var slideIndex = this.activeSlide - 1;
            if (slideIndex < 0) {
                this.goToSlide(this.slideCount - 1);
            }
            else {
                this.goToSlide(slideIndex);
            }
        };
        HammerjsCarouselComponent.prototype.nextSlide = function () {
            var slideIndex = this.activeSlide + 1;
            if (slideIndex === this.slideCount) {
                this.goToSlide(0);
            }
            else {
                this.goToSlide(slideIndex);
            }
        };
        HammerjsCarouselComponent.prototype.goToSlide = function (slideNumber) {
            var _this = this;
            if (slideNumber < 0) {
                this.activeSlide = 0;
            }
            else if (slideNumber > this.slideCount - 1) {
                this.activeSlide = this.slideCount - 1;
            }
            else {
                this.activeSlide = slideNumber;
            }
            this.isAnimating = true;
            var percentage = -(100 / this.slideCount) * this.activeSlide;
            this.sliderTransformStyle = 'translateX(' + percentage + '%)';
            clearTimeout(this.animatingTimeout);
            this.animatingTimeout = setTimeout(function () { return _this.isAnimating = false; }, 400);
        };
        HammerjsCarouselComponent.prototype.isActive = function (index) {
            return this.activeSlide === index;
        };
        HammerjsCarouselComponent.prototype.getWidthStyle = function () {
            if (this.width == null) {
                return null;
            }
            return (this.width / 13) + 'px';
        };
        HammerjsCarouselComponent.prototype.getMarginStyle = function () {
            if (this.width == null) {
                return null;
            }
            return (this.width / 30) + 'px';
        };
        HammerjsCarouselComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef }
        ]; };
        __decorate([
            core.Input()
        ], HammerjsCarouselComponent.prototype, "slides", null);
        __decorate([
            core.ViewChild('sliderWrapper')
        ], HammerjsCarouselComponent.prototype, "sliderWrapper", void 0);
        HammerjsCarouselComponent = __decorate([
            core.Component({
                // tslint:disable-next-line:component-selector
                selector: 'hammerjs-carousel',
                template: "\n  <div class=\"slider-wrapper\" #sliderWrapper>\n    <div class=\"slider\" (pan)=\"onPan($event)\" [style.transform]=\"sliderTransformStyle\" [style.width]=\"slideCount + '00%'\"\n         [ngClass]=\"{ 'is-animating': isAnimating }\">\n      <div class=\"slider-panel\" *ngFor=\"let slide of slides\" [style.background-image]=\"'url(' + slide + ')'\"></div>\n    </div>\n    <div class=\"slider-button left\" *ngIf=\"!isTouchDevice && slides?.length > 1\" (click)=\"previousSlide()\">\n        <svg class=\"chevron\" [style.width]=\"getWidthStyle()\" [style.margin-left]=\"getMarginStyle()\"\n        xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"17 15 13 20\" enable-background=\"new 17 15 13 20\" fill=\"#fff\">\n          <path d=\"M27.3 34.7L17.6 25l9.7-9.7 1.4 1.4-8.3 8.3 8.3 8.3z\"/>\n        </svg>\n    </div>\n    <div class=\"slider-button right\" *ngIf=\"!isTouchDevice && slides?.length > 1\" (click)=\"nextSlide()\">\n      <svg class=\"chevron right\" [style.width]=\"getWidthStyle()\" [style.margin-right]=\"getMarginStyle()\"\n      xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"17 15 13 20\" enable-background=\"new 17 15 13 20\" fill=\"#fff\">\n          <path d=\"M27.3 34.7L17.6 25l9.7-9.7 1.4 1.4-8.3 8.3 8.3 8.3z\"/>\n        </svg>\n    </div>\n    <div class=\"slider-pagination\" *ngIf=\"slides?.length > 1\">\n      <div *ngFor=\"let slide of slides; index as index;\" (click)=\"goToSlide(index)\">\n        <div class=\"slider-page\" [ngClass]=\"{ 'is-active': isActive(index) }\"></div>\n      </div>\n    </div>\n  </div>\n  ",
                styles: [".slider-wrapper{overflow:hidden;width:100%;height:100%;position:relative}.slider{display:-webkit-box;display:flex;height:100%}.slider.is-animating{-webkit-transition:-webkit-transform .4s cubic-bezier(.5,0,.5,1);transition:transform .4s cubic-bezier(.5,0,.5,1);transition:transform .4s cubic-bezier(.5,0,.5,1),-webkit-transform .4s cubic-bezier(.5,0,.5,1)}.slider-panel{width:100%;background-position:center center;background-repeat:no-repeat;background-size:cover}.slider-button{position:absolute;opacity:.7;height:100%;top:0;width:50%;cursor:pointer}.slider-button:hover{color:#fff;opacity:1}.slider-button.left{left:0}.slider-button.left:hover{background:-webkit-gradient(linear,right top,left top,from(rgba(255,255,255,0)),to(rgba(255,255,255,.3)));background:linear-gradient(270deg,rgba(255,255,255,0) 0,rgba(255,255,255,.3) 100%)}.slider-button.right{right:0}.slider-button.right:hover{background:-webkit-gradient(linear,left top,right top,from(rgba(255,255,255,0)),to(rgba(255,255,255,.3)));background:linear-gradient(90deg,rgba(255,255,255,0) 0,rgba(255,255,255,.3) 100%)}.slider-button .chevron{position:absolute;top:50%;-webkit-transform:translateY(-50%);transform:translateY(-50%)}.slider-button .chevron.right{right:0;-webkit-transform:translateY(-50%) rotate(180deg);transform:translateY(-50%) rotate(180deg)}.slider-pagination{bottom:6.25%;left:0;position:absolute;text-align:center;width:100%}.slider-pagination>div{padding:4px;display:inline-block;cursor:pointer}.slider-pagination .slider-page{border-radius:50%;box-shadow:0 0 0 2px rgba(255,255,255,.75);height:6px;-webkit-transition:background-color 250ms;transition:background-color 250ms;width:6px}.slider-pagination .slider-page.is-active{background-color:rgba(255,255,255,.75)}"]
            })
        ], HammerjsCarouselComponent);
        return HammerjsCarouselComponent;
    }());

    var GestureConfigService = /** @class */ (function (_super) {
        __extends(GestureConfigService, _super);
        function GestureConfigService() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        GestureConfigService.prototype.buildHammer = function (element) {
            var mc = new Hammer(element, {
                touchAction: 'pan-y',
                recognizers: [
                    [Hammer.Pan],
                ]
            });
            return mc;
        };
        GestureConfigService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function GestureConfigService_Factory() { return new GestureConfigService(); }, token: GestureConfigService, providedIn: "root" });
        GestureConfigService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], GestureConfigService);
        return GestureConfigService;
    }(platformBrowser.HammerGestureConfig));

    var HammerjsCarouselModule = /** @class */ (function () {
        function HammerjsCarouselModule() {
        }
        HammerjsCarouselModule = __decorate([
            core.NgModule({
                declarations: [HammerjsCarouselComponent],
                imports: [
                    platformBrowser.BrowserModule, platformBrowser.HammerModule
                ],
                exports: [HammerjsCarouselComponent],
                providers: [{
                        provide: platformBrowser.HAMMER_GESTURE_CONFIG,
                        useClass: GestureConfigService
                    }]
            })
        ], HammerjsCarouselModule);
        return HammerjsCarouselModule;
    }());

    exports.HammerjsCarouselComponent = HammerjsCarouselComponent;
    exports.HammerjsCarouselModule = HammerjsCarouselModule;
    exports.ɵa = GestureConfigService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-hammerjs-carousel.umd.js.map
