import { OnInit, ElementRef, AfterViewChecked, ChangeDetectorRef } from '@angular/core';
export declare class HammerjsCarouselComponent implements OnInit, AfterViewChecked {
    private cdRef;
    private slidesInternal;
    get slides(): string[];
    set slides(value: string[]);
    sliderWrapper: ElementRef;
    sliderTransformStyle: string;
    isAnimating: boolean;
    slideCount: number;
    isTouchDevice: boolean;
    width: number;
    private activeSlide;
    private sensitivity;
    private animatingTimeout;
    constructor(cdRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewChecked(): void;
    onPan(e: any): void;
    previousSlide(): void;
    nextSlide(): void;
    goToSlide(slideNumber: number): void;
    isActive(index: number): boolean;
    getWidthStyle(): string;
    getMarginStyle(): string;
}
